# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section     free
%define jettyname   jetty
%define servletspec 2.5
%define jspspec     2.0

Name:           jetty6-core
Version:        6.1.4
Release:        1jpp
Epoch:          0
Summary:        The Jetty Webserver and Servlet Container

Group:          Networking/Daemons
License:        Apache Software License
URL:            http://www.mortbay.org/
Source0:        http://dist.codehaus.org/jetty/jetty-6.1.4/jetty-6.1.4-src.zip
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-pom_xml.patch
Patch1:         %{name}-servlet-api-2.5-pom_xml.patch
Patch2:         %{name}-jsp-api-2.0-pom_xml.patch
Patch3:         %{name}-Jetty6PluginWebApplication.patch
Patch4:         %{name}-webapp-Configuration.patch
Patch5:         %{name}-annotation-Injection.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  maven2 >= 2.0.4-10jpp
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire

Requires(post):    jpackage-utils >= 0:1.7.2
Requires(postun):  jpackage-utils >= 0:1.7.2

%description
Jetty is a 100% Java HTTP Server and Servlet Container.

NOTE: This is a partial build of Jetty6.
      Some libraries for embedding only.
      And no JSP-2.1 support...
A full jetty6 build will appear in JPP-5.0 soon.

%package -n %{jettyname}6-servlet-%{servletspec}-api
Summary:        Servlet 2.5 API from %{name}
Group:          Networking/Daemons
Provides: servlet
Provides: servlet25


%description -n %{jettyname}6-servlet-%{servletspec}-api
%{summary}

%package -n %{jettyname}6-jsp-%{jspspec}-api
Summary:        JSP 2.0 API from %{name}
Group:          Networking/Daemons
Provides: jsp

%description -n %{jettyname}6-jsp-%{jspspec}-api
%{summary}

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description    javadoc
Javadoc for %{name}

%prep
%setup -q -n %{jettyname}-%{version}
cp %{SOURCE1} settings.xml
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jetty6
# servlet api subpackage install
install -m 644 lib/servlet-api-%{servletspec}-%{version}.jar \
        ${RPM_BUILD_ROOT}%{_javadir}/%{jettyname}6-servlet-%{servletspec}-api-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}
        ln -sf %{jettyname}6-servlet-%{servletspec}-api-%{version}.jar \
            %{jettyname}6-servlet-%{servletspec}-api.jar
popd
# jsp api subpackage install
install -m 644 lib/jsp-%{jspspec}/jsp-api-%{jspspec}.jar \
        ${RPM_BUILD_ROOT}%{_javadir}/%{jettyname}6-jsp-%{jspspec}-api-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}
        ln -sf %{jettyname}6-jsp-%{jspspec}-api-%{version}.jar \
            %{jettyname}6-jsp-%{jspspec}-api.jar
popd

install -pm 644 lib/jetty-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-%{version}.jar
install -pm 644 lib/jetty-util-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-util-%{version}.jar
install -pm 644 lib/ext/jetty-html-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-html-%{version}.jar
install -pm 644 lib/naming/jetty-naming-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-naming-%{version}.jar
install -pm 644 lib/management/jetty-management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-management-%{version}.jar
install -pm 644 lib/plus/jetty-plus-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jetty6-plus-%{version}.jar
install -pm 644 lib/jsp-2.0/jsp-api-2.0.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/jsp-2.0-%{version}.jar
install -pm 644 start.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/start-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/jetty6 && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%add_to_maven_depmap org.mortbay.jetty project %{version} JPP/jetty6 project
%add_to_maven_depmap org.mortbay.jetty jetty %{version} JPP/jetty6 jetty6
%add_to_maven_depmap org.mortbay.jetty jetty-html %{version} JPP/jetty6 jetty6-html
%add_to_maven_depmap org.mortbay.jetty jetty-util %{version} JPP/jetty6 jetty6-util
%add_to_maven_depmap org.mortbay.jetty jetty-naming %{version} JPP/jetty6 jetty6-naming
%add_to_maven_depmap org.mortbay.jetty jetty-management %{version} JPP/jetty6 jetty6-management
%add_to_maven_depmap org.mortbay.jetty jetty-plus %{version} JPP/jetty6 jetty6-plus
%add_to_maven_depmap org.mortbay.jetty servlet-api-2.5 %{version} JPP jetty6-servlet-2.5-api
%add_to_maven_depmap org.mortbay.jetty jsp-api-2.0 %{version} JPP jetty6-jsp-2.0-api
%add_to_maven_depmap org.mortbay.jetty jsp-2.0 %{version} JPP/jetty6 jsp-2.0

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-project.pom
install -pm 644 modules/jetty/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6.pom
install -pm 644 modules/html/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-html.pom
install -pm 644 modules/util/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-util.pom
install -pm 644 modules/naming/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-naming.pom
install -pm 644 modules/management/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-management.pom
install -pm 644 modules/plus/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-plus.pom
install -pm 644 modules/servlet-api-2.5/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-jetty6-servlet-2.5-api.pom
install -pm 644 modules/jsp-api-2.0/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-jetty6-jsp-2.0-api.pom
install -pm 644 modules/jsp-2.0/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.0.pom

install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post -n %{jettyname}6-servlet-%{servletspec}-api
update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{jettyname}6-servlet-%{servletspec}-api.jar 20600

%postun -n %{jettyname}6-servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet \
        %{_javadir}/%{jettyname}6-servlet-%{servletspec}-api.jar
fi

%post -n %{jettyname}6-jsp-%{jspspec}-api
update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/%{jettyname}6-jsp-%{jspspec}-api.jar 20000

%postun -n %{jettyname}6-jsp-%{jspspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove jsp \
        %{_javadir}/%{jettyname}6-jsp-%{jspspec}-api.jar
fi

%files
%defattr(-,root,root,-)
%doc *.txt
%{_javadir}/jetty6/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}

%files -n %{jettyname}6-servlet-%{servletspec}-api
%defattr(-,root,root,-)
%{_javadir}/%{jettyname}6-servlet-%{servletspec}-api*.jar

%files -n %{jettyname}6-jsp-2.0-api
%defattr(-,root,root,-)
%{_javadir}/%{jettyname}6-jsp-%{jspspec}-api*.jar

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Fri Jul 20 2007 Ralph Apel <r.apel at r-apel.de> - 0:6.1.4-1jpp
- First release

